#define B_CALL(xxxx)    rst 28h \ .dw xxxx
#define B_JUMP(xxxx)    call 50h \ .dw xxxx

_ClrLCDFull =4540h
_getkey     equ 4972h
_Newline    =452Eh
_DispHL     =4507h
_homeup     =4558h
_puts       =450Ah
_GetCsC     =4018h
_ClrScrnFull    =4546h
_PutMap     =4501h
_recabyte   =4F03h
_sendabyte  =4EE5h
_GrBufCpy   =486Ah
_displayimage  =4D9Bh
_PutMap     =4501h
_vputmap    =455eh
_vputs      =4561h
plotSScreen =9340h
kRight      =03h
kLeft       =02h
kUp         =04h
kDown       =01h
kClear      =0Fh
k2nd        =36h
CurRow      =844Bh
CurCol      =844Ch
penCol      =86D7h
x           =9872h
y           =9874h
yp          =9887h
yp2         =9889h
sndflag                =9885h
biggest               =9876h
bals        =9878h
height      =987Ah
player      =987Fh
a        =9881h
nballs   =988Ah

xoffsets    =9890h  
yoffsets    =98A0h  
xcoords     =98B0h  ;space for 16 balls
ycoords     =98C0h  ;up till 98CF used
collission_counter =98D0h
p128_ammo   =plotsscreen
p0_ammo     =plotsscreen+11
p128_height           =98D1h
p0_height           =98D2h
AIspeed     =98D3h
delay       =98D4h
advantage   =98D5h

    .org    9D93h
    .db $BB,$6D
;==================sync
    call clearscreen+2
    B_CALL(_GrBufCpy)
    ld hl, $0404
    ld (PenCol),hl
    ld hl, welcome+2
    B_CALL(_Vputs)
    ld hl, $0B04
    ld (PenCol),hl
    ld hl, chooseAIspeed+2
    B_CALL(_Vputs)
    ld a, 2
    ld (AIspeed), a
AIsetup
    ld a,85
    ld (pencol),a
    ld a, (AIspeed)
    push af
    ld b, $30
    add a, b
    B_CALL(_VPutMap)
    B_CALL(_Getkey)
    pop bc
    cp $03
    jr nz, not_up
    inc b
not_up
    cp $04
    jr nz, not_down
    dec b
not_down
    cp $09
    ret z
    push af
    ld a, b
    cp 3
    jr nc, invalid
    ld (AIspeed),a
invalid
    pop af
    cp $05
    jr nz, AIsetup
    
    ld hl, $1204
    ld (PenCol),hl
    ld hl, choosegamespeed+2
    B_CALL(_Vputs)
    ld a, 5
    ld (delay), a
speed_set_loop
    ld a,85
    ld (pencol),a
    ld a, (delay)
    push af
    ld b, $30
    add a, b
    B_CALL(_VPutMap)
    B_CALL(_Getkey)
    pop bc
    cp $03
    jr nz, speed_not_up
    inc b
speed_not_up
    cp $04
    jr nz, speed_not_down
    dec b
speed_not_down
    cp $09
    ret z
    push af
    ld a, b
    cp 8
    jr nc, speed_invalid
    cp 255
    jr z, speed_invalid
    ld (delay),a
speed_invalid
    pop af
    cp $05
    jr nz, speed_set_loop       

    ld hl, $1904
    ld (PenCol),hl
    ld hl, chooseadvantage+2
    B_CALL(_Vputs)
    ld a, 1
    ld (advantage), a
advantage_set_loop
    ld a,85
    ld (pencol),a
    ld a, (advantage)
    push af
    ld b, $30
    add a, b
    B_CALL(_VPutMap)
    B_CALL(_Getkey)
    pop bc
    cp $03
    jr nz, advantage_not_up
    inc b
advantage_not_up
    cp $04
    jr nz, advantage_not_down
    dec b
advantage_not_down
    cp $09
    ret z
    push af
    ld a, b
    cp 2
    jr z, advantage_invalid
    cp 255
    jr z, advantage_invalid
    ld (advantage),a
advantage_invalid
    pop af
    cp $05
    jr nz, advantage_set_loop        
;===========initialise
skipnull
    call clearscreen+2    
    ld a, 0
    ld hl, xoffsets
    ld b, 32
fill_offsets
    ld (hl),a
    inc hl
    djnz fill_offsets
    
    ld a, 28
    ld b, 32
fill_coords
    push bc
    ld (hl), a
    inc hl
    ld b, 1
    add a,b
    pop bc
    djnz fill_coords
    
    ld a, 1
    ld (xoffsets),a
    ld (yoffsets),a
  
    ld a, 8
    ld (height), a  ;paddle is 8 high
    ld a, 30
    ld (yp), a      ;put paddles at 30
    ld (yp2), a
    ld a, 1
    ld (nballs), a
    ld a, 15*16
    ld (p128_ammo),a
    ld a, 15
    ld (p0_ammo),a
    inc a
    ld (p0_height),a
    ld (p128_height),a
    xor a
    ld (collission_counter),a
;===============main program
mainloop
    call drawballs_routine+2
    
    ld a, (p128_height)
    ld (height), a
    ld ix, pong+2
    ld a, (yp)
    ld l, a
    ld a, 5
    call drawpixel+2
    
    ld a, (p0_height)
    ld (height), a
    ld ix, pong+2
    ld a, (yp2)
    ld l, a
    ld a, 83
    call drawpixel+2
    
    ld a, 8
    ld (height), a
    B_CALL(_GrBufCpy)
                    ;========collision checks===========   
    
    ld a, (advantage)
    or a
    jr nz, adv
    call checkleft+2
    call checkright+2
    jr checksdone
adv
    call checkright+2
    call checkleft+2
checksdone
    ld a, (nballs)
    ld b, a
checkabove
    push bc
    ld hl, ycoords-1
    ld a, b
    ld e, a
    ld d, 0 ;offset in b to de, add to hl
    add hl, de
    ld a, (hl)
    dec a
    ld l, a     ;to l
    push hl     ;save l
    ld hl, xcoords-1
    ld a, b
    ld e, a
    ld d, 0
    add hl, de
    ld a, (hl)  ;xcoord in a
    and %01111111
    inc a       ;to right
    inc a
    inc a
    pop hl      ;retrieve l
    call checkpixel+2
    pop bc
    push bc
    or a
    call nz, down+2    ;ball no. still in b
    pop bc
    djnz checkabove
    
    ld a, (nballs)
    ld b, a
checkunder
    push bc
    ld hl, ycoords-1
    ld a, b
    ld e, a
    ld d, 0 ;offset in b to de, add to hl
    add hl, de
    ld a, (hl)
    ld b, 8
    add a, b
    ld l, a     ;to l
    pop bc
    push bc     ;restore bc
    push hl     ;save l
    ld hl, xcoords-1
    ld a, b
    ld e, a
    ld d, 0
    add hl, de
    ld a, (hl)  ;xcoord in a
    and %01111111
    inc a       ;to right
    inc a
    inc a
    pop hl      ;retrieve l
    call checkpixel+2
    pop bc
    push bc
    or a
    call nz, up+2    ;ball no. still in b
    pop bc
    djnz checkunder
                        ;===========collission checks done======
    
    call drawballs_routine+2    ;clear balls
    
    ld a, (p128_height)
    ld (height), a
    ld ix, pong+2
    ld a, (yp)
    ld l, a
    ld a, 5
    call drawpixel+2
    
    ld a, (p0_height)
    ld (height), a
    ld ix, pong+2
    ld a, (yp2)
    ld l, a
    ld a, 83
    call drawpixel+2
    call checkbounds+2; still have to check for end of screen
    call AI+2
    
    ld a, 8     
    ld (height), a
    
    ld a,(nballs)
    ld b,a
move_loop
    push bc
    ld hl, xoffsets-1
    ld a, b
    ld e, a
    ld d, 0
    add hl, de
    ld a, (hl) ;offset
    push af     ;on stack
    ld hl, xcoords-1
    ld a, b
    ld e, a
    ld d, 0
    add hl, de
    ld a, (hl)  ;xcoord
    pop bc      ;pop offset
    add a, b    
    ld (hl),a   ;put back in (hl)
    pop bc
    push bc     ;restore bc
    ld hl, yoffsets-1
    ld a, b
    ld e, a
    ld d, 0
    add hl, de
    ld a, (hl) ;offset
    push af     ;on stack
    ld hl, ycoords-1
    ld a, b
    ld e, a
    ld d, 0
    add hl, de
    ld a, (hl)  ;xcoord
    pop bc      ;pop offset
    add a, b    
    ld (hl),a   ;put back in (hl)
    pop bc
    djnz move_loop
        
    ld a, (collission_counter)  ;check if a ball can be deleted
    cp 7
    call nc, delete_ball+2
    
    ld a, $FD       ;keyboard input
    out (1), a
    NOP
    NOP
    in a, (1)
    cp $BF
    ret z
    ld a, $FE
    out (1), a
    NOP
    NOP
    in a, (1)
    push af
    cp $FE
    call z, pongdown+2
    pop af
    cp $F7
    call z, pongup+2
    ld a, $BF
    out (1), a
    NOP
    NOP
    in a, (1)
    cp $DF
    jr nz, pressed
    ld b, %10000000 ;player 128 added the ball
    call addball+2   ;2nd key -> add ball
pressed
    ld a, $DF
    out (1),a
    nop
    nop
    in a, (1)
    cp $7F
    jr z, pressed
    ld a, $BF
    out (1),a
    nop
    nop
    in a, (1)
    cp $BF
    jp z, skipnull+2
    ld a, (delay)
    sla a       ;18
    sla a       ;36
    sla a       ;72
    sla a       ;144
    sla a
    inc a
    ld b,a
delay_1
    push bc
    ld b, 3
delay_2
    djnz delay_2
    pop bc
    djnz delay_1
    jp mainloop+2
   ;==================subroutines
drawpixel       ;sprite
    push af
    ld a, l
    cp 56
    jr c, y_ok
    pop af 
    ret
y_ok
    pop af
    call getpixel+2
    ld (a), a
    ld a, (height)
    ld b, a
loop
    push bc
    ld a, (ix)
    ld d, a
    ld a, 0
    ld e, a
    ld a, (a)
    or a
    jp z, skipshift+2
    ld b, a
shiftloop
    srl d
    rr e
    djnz shiftloop
skipshift
    ld a, (hl)
    ld b, a
    ld a, d
    xor b
    ld (hl), a
    inc hl
    ld a, (hl)
    ld b, a
    ld a, e
    xor b
    ld (hl), a
    ld de, 11
    add hl, de
    pop bc
    inc ix
    djnz loop
    ret

getpixel    ;getpixel routine
    LD     H, 0
    LD     D, H
    LD     E, L
    ADD    HL, HL
    ADD    HL, DE
    ADD    HL, HL
    ADD    HL, HL

    LD     E, A
    SRL    E
    SRL    E
    SRL    E
    ADD    HL, DE
    AND %00000111
    LD     DE, plotSScreen
    ADD    HL, DE
    ret
    
checkpixel  ;check if pixel set, if a is not zero, there is a pixel
    call getpixel+2
    push af
    ld a, %10000000
    ld c, a
    pop af
    or a
    jr z, skipsh
    ld b, a
sh
    srl c
    djnz sh
skipsh
    ld a, c
    ld b, a
    ld a, (hl)
    and b
    ret
        
right   ;load values for ball
    ld hl, xoffsets-1
    ld a, b
    ld e, a
    ld d, 0
    add hl, de
    ld a, 1
    ld (hl),a
    ret
left   ;load values for ball
    ld hl, xoffsets-1
    ld a, b
    ld e, a
    ld d, 0
    add hl, de
    ld a, 255
    ld (hl),a
    ret
up   ;load values for ball
    ld hl, yoffsets-1
    ld a, b
    ld e, a
    ld d, 0
    add hl, de
    ld a, 255
    ld (hl),a
    ld a, (collission_counter)
    inc a
    ld (collission_counter),a
    ret
down   ;load values for ball
    ld hl, yoffsets-1
    ld a, b
    ld e, a
    ld d, 0
    add hl, de
    ld a, 1
    ld (hl),a
    ret
pongdown
    ld a, (yp)
    cp 48
    ret z
    inc a
    inc a
    ld (yp), a
    ret 
pongup
    ld a, (yp)
    or a 
    ret z
    dec a
    dec a
    ld (yp), a
    ret  
clearscreen
    ld hl, plotsscreen
    xor a
    ld b, 12
clearscreen_toploop
    ld (hl),a
    inc hl
    djnz clearscreen_toploop
    ld a, 255
    ld b, 24
clearscreen_loop1
    ld (hl), a
    inc hl
    djnz clearscreen_loop1
    ld b, 58
clearscreen_loop2
    ld a, 128+64+32
    ld (hl), a
    inc hl
    xor a 
    ld (hl),a
    inc hl
    ld (hl),a
    inc hl
    ld (hl),a
    inc hl
    ld (hl),a
    inc hl
    ld (hl),a
    inc hl
    ld (hl),a
    inc hl
    ld (hl),a
    inc hl
    ld (hl),a
    inc hl
    ld (hl),a
    inc hl
    ld (hl),a
    inc hl
    ld a, 7
    ld (hl), a
    inc hl
    djnz clearscreen_loop2
    ld a, 255
    ld b, 36
clearscreen_loop3
    ld (hl), a
    inc hl
    djnz clearscreen_loop3
    ret
    
drawballs_routine       ;draw all balls in game
    ld a, (nballs)  ;draw max 15 balls
    cp 16
    jr c, ballsok
    ld a, 15
    ld (nballs),a
ballsok
    ld b, a
    
drawballs   
    push bc    
    ld ix, bal+2
    ld hl,ycoords-1
    ld a,b ;add number off balls
    ld e, a
    ld d, 0
    add hl, de
    ld a, (hl)  ;coord. of ball
    ld l, a
    push hl ;save l
    ld hl,xcoords-1
    ld a,b ;add number off balls
    ld e, a
    ld d, 0
    add hl, de
    ld a, (hl)  ;coord. of ball
    and %01111111
    pop hl
    call drawpixel+2
    pop bc
    djnz drawballs
    ret

addball
    ld a, b
    or a
    jr z, add_p0
    ld a, (p128_ammo)
    or a
    ret z
    sla a   ;rotate left, p128 is left paddle
    ld (p128_ammo),a
    ld a, (nballs)
    inc a
    ld (nballs),a   ;increase nballs
    ld hl, ycoords-1
    ld e, a
    ld d, 0
    add hl, de
    ld a, (yp)
    ld b, 2
    add a, b
    ld (hl),a   ;yp+4 to ycoord
    ld hl, xcoords-1
    add hl,de
    ld (hl),13+128  ;xcoord=10, bit 7 set
    ld hl,xoffsets-1
    add hl,de
    ld a, 1
    ld (hl),a
    xor a
    ld (collission_counter),a
    ret
add_p0
    ld a, (p0_ammo)
    or a
    ret z
    srl a   
    ld (p0_ammo),a
    ld a, (nballs)
    inc a
    ld (nballs),a   ;increase nballs
    ld hl, ycoords-1
    ld e, a
    ld d, 0
    add hl, de
    ld a, (yp2)
    ld b, 2
    add a, b
    ld (hl),a   ;yp2+4 to ycoord
    ld hl, xcoords-1
    add hl,de
    ld a, 88-13
    ld (hl),a  ;xcoord=13 to left, b7 reset
    ld hl,xoffsets-1
    add hl,de
    ld a, 255
    ld (hl),a
    xor a
    ld (collission_counter),a
    ret
    
delete_ball
    xor a
    ld (collission_counter),a
    ld a, (nballs)
    cp 1
    ret z
    dec a
    ld (nballs),a
    ld hl,xcoords
    ld e, a
    ld d,0
    add hl, de
    ld a,(hl)
    and 128
    jr nz, addammo_p0
    ld a, (p128_ammo)
    rr a
    or 128
    ld (p128_ammo),a
    ret
addammo_p0
    ld a, (p0_ammo)
    rl a
    or 1
    ld (p0_ammo),a
    ret
    
checkbounds
    ld a, (nballs)
    ld b, a
checkbounds_loop
    push bc
    ld hl, ycoords-1
    ld a, b
    ld e, a
    ld d, 0 ;offset in b to de, add to hl
    add hl, de
    ld a, (hl)
    push af
    cp 55
    call z, up+2
    pop af
    cp 1
    call z, down+2
    pop bc
    push bc     ;restore bc
    
    ld hl, xcoords-1
    ld a, b
    ld e, a
    ld d, 0
    add hl, de
    ld a, (hl)  ;xcoord in a
    and %01111111
    push af
    cp 84
    jr nz, not_rightbound
    call left+2
    ld a, (p0_height)
    dec a
    or a
    jr z, p0_heightzero
    ld (p0_height),a
p0_heightzero
    ld a, (p128_height)
    inc a
    cp 17
    jr z, not_rightbound
    ld (p128_height),a
not_rightbound    
    pop af
    cp 3
    jr nz, not_leftbound
    call right+2
    ld a, (p128_height)
    dec a
    or a
    jr z, p128_heightzero
    ld (p128_height),a
p128_heightzero
    ld a, (p0_height)
    inc a
    cp 17
    jr z, not_leftbound
    ld (p0_height),a
not_leftbound    
    pop bc
    djnz checkbounds_loop
    ret 
AI
    ld c, 0
    ld a, (nballs)
    ld b, a
closest_loop
    ld hl, xcoords-1
    ld a, b
    ld e, a
    ld d, 0
    add hl, de
    ld a, (hl)  ;xcoord in a 
    and %01111111 
    cp c
    jr c, not_bigger
    ld c, a     ;if a bigger than c, a to c
    ld a, b        
    ld (biggest),a  ;save b
not_bigger
    djnz closest_loop
    ld hl, ycoords-1
    ld a, (biggest)
    ld e, a
    ld d, 0
    add hl, de
    ld a, (AIspeed)
    ld b, a
    ld a, (hl)  ;find desired y value
    ld c, a
    ld a, (yp2)
    sub b
    cp c
    jr nc, c_not_bigger_than_a
    add a,b
    add a,b
c_not_bigger_than_a
    cp 53
    jr nc, too_low
    ld (yp2),a
    ld b, 0
    cp 34
    call z, addball+2 
too_low
    ret
    
checkright
    ld a, (nballs)
    ld b, a
checkright_loop
    push bc
    ld hl, ycoords-1
    ld a, b
    ld e, a
    ld d, 0 ;offset in b to de, add to hl
    add hl, de
    ld a, (hl)
    ld b, 3
    add a, b    ;add 3 ->middle
    ld l, a     ;to l
    pop bc      ;restore bc
    push bc
    push hl     ;save l
    ld hl, xcoords-1
    ld a, b
    ld e, a
    ld d, 0
    add hl, de
    ld a, (hl)  ;xcoord in a
    and %01111111
    push bc
    ld b, 8
    add a, b
    pop bc      ;add 8 and save ball no
    pop hl      ;retrieve l
    call checkpixel+2
    pop bc
    push bc
    or a
    call nz, left+2    ;ball no. still in b
    pop bc
    djnz checkright_loop 
    ret
    
checkleft
    ld a, (nballs)
    ld b, a
checkleft_loop
    push bc
    ld hl, ycoords-1
    ld a, b
    ld e, a
    ld d, 0 ;offset in b to de, add to hl
    add hl, de
    ld a, (hl)
    ld b, 3
    add a, b    ;add 3 ->middle
    ld l, a     ;to l
    pop bc      ;restore bc
    push bc
    push hl     ;save l
    ld hl, xcoords-1
    ld a, b
    ld e, a
    ld d, 0
    add hl, de
    ld a, (hl)  ;xcoord in a
    and %01111111
    dec a       ;to left
    pop hl      ;retrieve l
    call checkpixel+2
    pop bc
    push bc
    or a
    call nz, right+2    ;ball no. still in b
    pop bc
    djnz checkleft_loop
    ret
        
bal
    .db %00111100
    .db %01110010
    .db %11111001
    .db %11111101
    .db %11111101
    .db %11111111
    .db %01111110
    .db %00111100
pong
    .db %00111100
    .db %01000010
    .db %01001010
    .db %01111110
    .db %01000010
    .db %01110110
    .db %01000010
    .db %01111110
    .db %01000010
    .db %01011010
    .db %01000010
    .db %01111110
    .db %01000110
    .db %01010110
    .db %01000010
    .db %00111100
welcome
    .db "Welcome to multipong",0    ;0,1   
calcdetected
    .db "player detected",0
nocalcdetect
    .db "no link detected",0
chooseAIspeed
    .db "set speed of AI",0
choosegamespeed
    .db "set game speed",0
chooseadvantage
    .db "advantage?",0

.end
END
